/*
 * $Id: StateHandling.js,v 1.54.2.1 2005/06/02 13:22:31 kps Exp $
 */

// -----------------------  Short Name Declarations ---------------------------
/**
 * Applications should not use the letters 'p', 'w' & 'd' as variable names as
 * they are used by the framework.
 */

var p = parent;
var w = window;
var d = document;

// -------------------  Browser Determination Code ----------------------------

var browser_opera = false;
var browser_ie = false;
var browser_nn6 = false;
var browser_nn4 = false;

if (d.all)
{
  if (w.navigator.appName.toUpperCase=="OPERA")
	browser_opera=true;
  else
	browser_ie=true;
}
else if (d.layers || (!d.all && d.getElementById))
  browser_nn6=true;
else if (d.layers)
  browser_nn4=true; 


// ------------ Cookie Related Functions ---------------------

function getCookie (name) 
{
  var arg = name + "=";  
  var alen = arg.length;  
  var clen = d.cookie.length;  
  var i = 0;  
  while (i < clen) {    
    var j = i + alen;    
    if (d.cookie.substring(i, j) == arg)      
      return getCookieVal (j);    
    i = d.cookie.indexOf(" ", i) + 1;    
    if (i == 0) break;   
  }  
  return null;
}

function getCookieVal(offset) 
{
  var endstr = d.cookie.indexOf (";", offset);
  if (endstr == -1)
    endstr = d.cookie.length;
  return unescape(d.cookie.substring(offset, endstr));
}

function setCookie (name, value) 
{  
  var argv = setCookie.arguments;  
  var argc = setCookie.arguments.length;  
  var expires = (argc > 2) ? argv[2] : null;  
  var path = (argc > 3) ? argv[3] : null;  
  var domain = (argc > 4) ? argv[4] : null;  
  var secure = (argc > 5) ? argv[5] : false;  
  d.cookie = name + "=" + escape (value) + 
    ((expires == null) ? "" : ("; expires=" + expires.toGMTString())) + 
    ((path == null) ? "" : ("; path=" + path)) +  
    ((domain == null) ? "" : ("; domain=" + domain)) +    
    ((secure == true) ? "; secure" : "");
}

function deleteCookie (name) 
{  
  var exp = new Date();  
  exp.setTime (exp.getTime() - 1);  
  var cval = getCookie(name);  
  d.cookie = name + "=" + cval + "; expires=" + exp.toGMTString();
}

//------------------------------- Cookie related functions end ---------------------

/**
 * Returns the uniqueId for the passed variable. The variable can sometimes be the
 * required uniqueId itself or the referenceId. 
 * Incase passed variable is null, null is returned back.
 * Note: There is an issue if the uniqueId itself is a number.
 */
function getUniqueId(variable){
       if(variable == null)
       {
          return null;
       }

	if(isNaN(variable)){
		return variable;
	}
	return referenceIds[variable]; 
}

/**
 * Returns the referenceId for the passed variable. The variable can sometimes be the
 * required referenceId itself or the uniqueId. 
 *
 * Note: There is an issue if the uniqueId itself is a number.
 */
function getReferenceId(variable){
	if(isNaN(variable)){
           if(stateData[variable] == null)
           {
                alert(variable)
                return variable;
           }
           return stateData[variable]["ID"]; 
	}
	return variable;
}

/**
 * Initializes the main view by creating a stateData and a referenceIds object.
 * The stateData contains state for each subview and the referenceIds contains
 * each views referenceId. The values for a view can be retrieved at any point
 * of time by using the getUniqueId(id) and the getReferenceId(id) methods.
 */
function initializeMainView(win,rootViewId,context,themedir)
{
  win.postInvokeScripts = new Array();      
  if(win.name.indexOf("_RESPONSEFRAME") > 0)
  {
    win.stateData = p.stateData;   
    win.referenceIds = p.referenceIds;        
    win.SUBREQUEST=true;  
  }
  else
  {
    win.stateData = new Object();
    win.referenceIds = new Object();
    win.oldViews = new Object();
  }
  win.ROOT_VIEW_ID= rootViewId;
  win.CONTEXT_PATH=context;
  win.THEME_DIR=themedir;   
}

function createView(win,uniqueId,viewName,requestParams,parentView,parentDCA,refId,viewGenTime)
{
  var newView = new Object();
  newView["_VN"] = viewName;
  newView.ID = refId;
  if(requestParams != null)
  {
      newView["_D_RP"] = requestParams;
  }
  newView.PDCA = parentDCA;
  if((win.SUBREQUEST) && (uniqueId == win.ROOT_VIEW_ID)
    && stateData[uniqueId])
  {
	 newView["_PV"] = stateData[uniqueId]["_PV"];
  }
  else
  {
      newView["_PV"] = getReferenceId(parentView);
  }
  stateData[uniqueId] = newView;
  referenceIds[refId] = uniqueId;
  newView["VGT"]=viewGenTime;
  return newView;
}
 
function updateExistingView(uniqueId,parentViewId,parentDCA)
{
   stateData[uniqueId]["_PV"]= parentViewId;
   stateData[uniqueId]["PDCA"] = parentDCA;
}


function updateState(id,stateName,stateValue,resetStateId)
{
  var uniqueId = getUniqueId(id);
  if(stateValue)
  {
    encodeAndUpdateState(stateData[uniqueId],stateName,stateValue);
  }
  else
  {
    stateData[uniqueId][stateName]= null;
  }

  if(resetStateId)
  {
    stateData[uniqueId]["_VMD"]= '1';
  }
}

function encodeAndUpdateState(stateObj,stateName,stateVal)
{
  var sTypeOf = typeof stateVal;
  if(sTypeOf == "string")
  { 
     stateObj[stateName] = stateVal;
     return;
  } 
  if(sTypeOf != "object")
  {
    alert("encodeAndUpdateState: " + sTypeOf + " Data Type cannot be stored as state");
      
  }
  var fConstructor = stateVal.constructor;
  if( fConstructor == "array")
  {
     var stateValArr = "";
     for( var i in stateVal)
     {
        stateValArr += stateVal[i] + ",";
     }
     stateObj[stateName + "_COL_"] = stateValArr; 
  }
  else 
  {
     var stateValMap = "";
     for( var i in stateVal)
     {
        stateValMap += i + "," + stateVal[i] + ",";
     }
     stateObj[stateName + "_MAP_"] = stateValMap;      
  }
}

function handleStateForForm(frm,id,rootViewId,isSubReq,target)
{
  if(frm.action.indexOf("STATE_ID") > -1)
  {
    //User must have double clicked!!!
    return;
  }

  var uniqueId = getUniqueId(id);

  if(isSubReq)
  {
    if(target == null)
    {
      target = parent.ROOT_VIEW_ID + "_RESPONSEFRAME"
    }  
     addHiddenInput(frm,"SUBREQUEST","true");
  }
  if(target != null)
  {
    setAttrOnFrm(frm,"target",target);
  }
  url = updateStateCookieAndAppendSid(frm.action,rootViewId);
  if(uniqueId != null)
  {
    url =  getURLSuffixed(url);
    url += "ACTION_SOURCE=" + uniqueId;
  }
  frm.action=url;
  return true;
}


function updateStateCookieAndAppendSid(url,rootViewId)
{
  //loc: options - with state id & without state id
  //url: options - absolute, relative.
  var curDate = new Date();
  var stateTime= curDate.getTime();
  var stateStr = "STATE_ID/" + stateTime; 
  var newUrl = null;
  var newPath = null;
  if(url.charAt(0) == '/')
  {
    alert("Absolute URL is currently not supported");
    return null;
  }
  else
  {
    var curLocation = w.location; 
    newPath  = curLocation.pathname;
    newPath = newPath.substring(0,newPath.lastIndexOf('/'));
    if(newPath.indexOf("STATE_ID/") > -1)
    {
      newPath =  newPath.replace(/STATE_ID\/[^\/]*/g,stateStr) + "/" + url;        
    }      
    else
    {
      var ctxIndex = newPath.indexOf(CONTEXT_PATH)+ CONTEXT_PATH.length +1;
      newPath = newPath.substring(0,ctxIndex) + "/" + stateStr + "/" + url;
    }
    var curHost = curLocation.host;
    if((curLocation.port != null) && (curLocation.port != "") && (curHost.indexOf(":" + curLocation.port) < 1))
    {
       curHost += ":" + curLocation.port;
    } 
    newUrl = curLocation.protocol + "//" + curHost + newPath;
  } 
  updateStateCookie(CONTEXT_PATH + "/"  + stateStr,stateTime,rootViewId);
  return newUrl;
}

function updateStateCookie(path,stateTime,rootViewId)
{
	var queryStr = "";
	if(rootViewId != null)
	{//TODO contentarea fix- To support partial refresh.
		stateData[rootViewId]["ORIGROOT"] = getReferenceId(ROOT_VIEW_ID);
	}
        checkForCacheSize();

	for(var name in stateData)
	{
        	queryStr += "&" + name;
		for( var i in stateData[name])
		{
                        var val = stateData[name][i];
			if(val && ((i != "_VN") || (val != name)))
			{ 
				val = escape(val);
				val = val.replace(/\//g,"//");
				queryStr += "/"  + i + "/" + val;
			}
		}
	}
	if(!rootViewId)
	{
		rootViewId = ROOT_VIEW_ID;
	}

	queryStr += "&_REQS/_RVID/" + rootViewId;
	queryStr +="/_TIME/"+ stateTime;
        var len =0;
	for(var name in stateData)
	{
          if(stateData[name]["_D_RP"])
          {
            len += stateData[name]["_D_RP"].length;
          }
        }
        //alert("Length of Req " + len);
        setCookieBasedOnSize(queryStr,path);
}


function setCookieBasedOnSize(stateStr,path)
{
	if(stateStr.length > 3000){
		var number = Math.floor(stateStr.length / 3000);
		var startIdx = 0;
		var endIdx = 0;
		for(var count = 0; count <= number; count++){
			if(count == 0){
				startIdx = 0;
			}
			else{
				startIdx = count*3000 + 1;
			}
			if(count == number){
				endIdx = stateStr.length;
			}
			else {
				endIdx = (count+1)*3000 + 1;
			}
			var str = stateStr.substring(startIdx, endIdx);
			setCookie("STATE_COOKIE" + count,str,null,path);
		}
	}
	else {
	setCookie("STATE_COOKIE",stateStr,null,path);
	}

}

function removeStateForView(viewToRemove)
{
  var toProcessList = new Array();
  toProcessList.push(viewToRemove);
  var removedViewsNum = 0;
  while(toProcessList.length > 0)
  {
     var curUniqueId = toProcessList.pop();
     var curRefId = getReferenceId(curUniqueId);
     internalRemoveStateForView(curUniqueId); 
     //alert("Removing " + curUniqueId);
     removedViewsNum++;
     for(var name in stateData)
     {
        if(stateData[name] && (stateData[name]["_PV"] == curRefId))
        {
           toProcessList.push(name);
        } 
     } 
  }  
  defragState();
  return removedViewsNum;
}

function defragState()
{
  stateData = defragObject(stateData);
  oldViews = defragObject(oldViews);
  referenceIds = defragObject(referenceIds);
}

function internalRemoveStateForView(viewToRemove)
{
   stateData[viewToRemove] = null;
   oldViews[viewToRemove] = null;
   referenceIds[viewToRemove]= null;      
}

function defragObject(sparseObj)
{
  var newObj = new Object();
  for(var name in sparseObj)
  {
    if(sparseObj[name])
    {
      newObj[name] = sparseObj[name];
    }
  }
  return newObj;
}

function checkForCacheSize()
{
  var viewsToRemove = new Array();
  var cursor = 0;
  for(var name in stateData)
  {
    viewsToRemove[cursor++] = name;
  }
  var size = viewsToRemove.length;
  if(size < 50)
  {
     return;
  }

  var toRemove = removeCachedViewsState(viewsToRemove,true,size - 30);
  if(toRemove > 0)
  {
    removeCachedViewsState(viewsToRemove,false,toRemove);
  }
  //alert(getObjectSize(stateData));
}

function removeCachedViewsState(viewsToRemove,checkReqParam,toRemove)
{
  for(var i = 0; i < viewsToRemove.length; i++)
  {
    var name = viewsToRemove[i];
    if(!stateData[name])
    {
      continue;
    }
    if(!checkReqParam || (stateData[name]["_D_RP"] != null))
     {
        if(!isViewStateNeeded(name))
        {
           toRemove = toRemove - removeStateForView(name);
           //alert("To Remove is now " + toRemove);
           if(toRemove < 1)
           {
             break;
           }
        }
     }
  } 
  return toRemove;
}

function getObjectSize(obj)
{
  var i = 0;
  for(var name in obj)
  {
    i++;
  }
  return i;
}
